#include "globaleFunksjoner.h"

using namespace std;

extern Stoppesteder* gStoppesteder;
extern Ruter* gRuter;

void skrivMeny() {
    cout << "\n\nS N - Nytt stoppested" << '\n'
         << "S A - Skriv alle stoppesteder" << '\n'
         << "S E - Søk på spesifikk stoppested" << '\n'
         << "R N - Ny rute" << '\n'
         << "R A - Skriv kort alle ruter" << '\n'
         << "R E - Endre rute" << '\n'
         << "R B - Rute beskrivelse" << '\n'
         << "R T - Rutetabell" << '\n'
         << "Q - Avslutt" << '\n';
}

void meny() {
    HjelpeFunksjoner hjelp;
    string valg;
    vector<char> valgChars;
    bool igjen;
    do {
        igjen = true;
        skrivMeny();
        cout << "Kommando: ";
        getline(cin, valg);
        valgChars = delOppValg(valg);
        if (valgChars.size() > 0) {
            switch (valgChars.front()) {
                case 'S':
                    // Slikt at .back() ikke kaster ut en error
                    if (valgChars.size() > 1)
                        gStoppesteder->meny(valgChars.back());
                    else
                        cout << "\nUgyldig valg!" << '\n';
                    break;
                case 'R':
                    // Slikt at .back() ikke kaster ut en error
                    if (valgChars.size() > 1)
                        gRuter->meny(valgChars.back());
                    else
                        cout << "\nUgyldig valg!" << '\n';
                    break;
                case 'Q':
                    break;
                default:
                    cout << "\nUgyldig valg!" << '\n';
                    break;
            }
            if (valgChars.front() == 'Q') igjen = false;
        } else
            cout << "\nUgyldig valg!" << '\n';
        // Så lenge brukren trykker q/Q
    } while (igjen);
}

vector<char> delOppValg(const std::string& str) {
    HjelpeFunksjoner hjelp;
    vector<string> tmp;
    vector<char> valg;
    int i = 0;
    tmp.push_back(hjelp.rensStreng(str));
    tmp = hjelp.splittStreng(' ', tmp.back());
    if (tmp.size() > 0 && tmp.size() < 3) {
        for (auto val : tmp) {
            val = hjelp.gjorOmTilStorBokstav(val);
            if (val == "S" || val == "R" || val == "Q" || val == "E" ||
                val == "N" || val == "A" || val == "B" || val == "T")
                valg.push_back(static_cast<char>(val.front()));
        }
    }
    return valg;
}

void ryddOppMinne() {
    delete gStoppesteder;
    delete gRuter;
}